#include<stdlib.h>
#include<stdio.h>
#include<unistd.h>
#include<mpi.h>

int mpi_rank=0;
int mpi_size=1;

#define BUFSIZE 256

int main(int argc, char ** argv){
    MPI_Init(&argc,&argv);
    if ( argc != 2){
        fprintf(stderr,"Usage %s: <hello-message>\n",argv[0]);
        exit(EXIT_FAILURE);
    }

    /* Get the rank of each process */
    MPI_Comm_rank(MPI_COMM_WORLD, &mpi_rank);

    /* Get the size of the communicator */
    MPI_Comm_size(MPI_COMM_WORLD, &mpi_size);

    char hostname_buf[BUFSIZE];
    if(gethostname(hostname_buf,BUFSIZE) != 0){
	    fprintf(stderr,"[ERROR]: gethostname process %i\n",mpi_rank);
    } else { 
    	printf("I am process %i out of %i on host %s . %s\n", mpi_rank, mpi_size,hostname_buf,argv[1]);
    }
    MPI_Finalize();
    return 0;
}
